<?php

namespace Netzmacher\Browser\Utility\UserFunc;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2010-2018 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class provides methods for the extension manager.
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage    browser
 * @version 8.7.2
 * @since 3.6.1
 */
class ExtManager
{
  /**
   * promptExternalLinks(): Displays the quick start message.
   *
   * @return	string		message wrapped in HTML
   * @since 3.6.1
   * @version 3.6.1
   */
  public function promptExternalLinks()
  {
//.message-notice
//.message-information
//.message-ok
//.message-warning
//.message-error

    $str_prompt = null;

    $str_prompt = $str_prompt . '
<div class="typo3-message message-information">
	<div class="message-body">
		' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:browser/Resources/Private/Language/UserFunc/locallang.xml:promptExternalLinksBody' ) . '
	</div>
</div>';

//      // #48613, dwildt, 3+
//    $arrDefinedConstants  = get_defined_constants( );
//    $path_typo3conf       = $arrDefinedConstants['PATH_typo3conf'];
//    $str_prompt           = str_replace( '%PATH_typo3conf%', $path_typo3conf, $str_prompt );
//      // #48613, dwildt, 3+

    return $str_prompt;
  }

  /**
   * promptRadialsearch(): Displays the quick start message.
   *
   * @return	string		message wrapped in HTML
   * @since 3.6.1
   * @version 3.6.1
   */
  public function promptRadialsearch()
  {
//.message-notice
//.message-information
//.message-ok
//.message-warning
//.message-error

    $str_prompt = null;

    $key = 'radialsearch';

    if ( \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded( $key ) )
    {
      $str_prompt = $str_prompt . '
<div class="typo3-message message-ok">
  <div class="message-body">
    ' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:browser/Resources/Private/Language/UserFunc/locallang.xml:promptRadialsearchIsLoadedBody' ) . '
  </div>
</div>';
    }
    else
    {
      $str_prompt = $str_prompt . '
<div class="typo3-message message-warning">
  <div class="message-body">
    ' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:browser/Resources/Private/Language/UserFunc/locallang.xml:promptRadialsearchIsNotLoadedBody' ) . '
  </div>
</div>';
    }

    $str_prompt = $str_prompt . '
<div class="typo3-message message-information">
  <div class="message-body">
    ' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:browser/Resources/Private/Language/UserFunc/locallang.xml:promptRadialsearchInfoBody' ) . '
  </div>
</div>';

    return $str_prompt;
  }

}