<?php

namespace Netzmacher\Browser\ViewHelpers\TxPowermail\v3011000\Getter;

use Netzmacher\Browser\ViewHelpers\TxPowermail\v3011000\Getter\BrowserViewHelper;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2017-2018 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class BrowserSelectboxViewHelper
 *
 * @package Netzmacher\Browser\ViewHelpers\TxPowermail\v3011000\Getter
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @version 8.0.21
 * @since 8.0.7
 * @internal #i0119
 */
class BrowserSelectboxViewHelper extends BrowserViewHelper
{

	/**
	 * _mapRowsSqlQuerySelectSingle( ) :
	 *
	 * @access private
	 * @return string $query
	 * @internal #i0304
	 * @version 8.0.21
	 * @since 8.0.21
	 */
	public function _mapRowsSqlQuerySelectSingle()
	{
		$query = '
      SELECT    uid, 
								title
      FROM      ' . $this->_tableForeign . '
      WHERE     pid IN (' . $this->_getPidList() . ')
      ORDER BY  title;
    '
		;
		return $query;
	}

	/**
	 * render( )  : Returns an array proper for the options property of the fluid form selectfield
	 *
	 * @access public
	 * @return array $options
	 * @version 8.0.21
	 * @since 8.0.21
	 */
	public function render()
	{
		$rows = parent::render();

		foreach( $rows as $row )
		{
			foreach( $row as $elements )
			{
				$options[ $elements[ 'uid' ] ] = $elements[ 'title' ];
			}
		}

		if( $this->arguments[ 'field' ]->isMandatory() )
		{
			return $options;
		}

		$options = array( 0 => null ) + ( array ) $options;
		return $options;
	}

}
