<?php

namespace Netzmacher\Browser\ViewHelpers\TxPowermail\v5000000\Misc;

use In2code\Powermail\Domain\Model\Field;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper;

/**
 * Prefill a multi field
 *
 * @package TYPO3
 * @subpackage Fluid
 * @version
 */
class PrefillFieldViewHelper extends AbstractViewHelper
{


  /**
   * Init
   *
   * @return void
   */
  public function initialize()
  {
    $this->_PowermailGP = GeneralUtility::_GP( 'tx_powermail_pi1' );
  }

	/**
   * Prefill fields from type
   *        check
   *        radio
   *
   * @param Field $field  field
   * @param string $value field value
   * @return bool Prefill field
   */
  public function render( Field $field, $value )
  {
    $fieldMarker = $field->getMarker();
    //var_dump( __METHOD__, __LINE__, $fieldMarker, $value );
    $pmGPFields = ( array ) $this->_PowermailGP[ 'field' ];
    //var_dump( __METHOD__, __LINE__, $fieldMarker, array_keys( $pmGPFields ) );
    if ( !in_array( $fieldMarker, array_keys( $pmGPFields ) ) )
    {
      return NULL;
    }
    $pmGPFieldValues = ( array ) $pmGPFields[ $fieldMarker ];
    //var_dump( __METHOD__, __LINE__, $pmGPFieldValues );
    //var_dump( __METHOD__, __LINE__, $field->getMultiselectForField() );
		switch(true) {
			case(empty($pmGPFieldValues)):
				$result = 0;
				break;
			case(count($pmGPFieldValues) == 1):
				$key = key($pmGPFieldValues);
				$result = $pmGPFieldValues[$key];
				break;
			case(count($pmGPFieldValues) > 1):
				$result = $pmGPFieldValues;
				break;
		}
    //var_dump( __METHOD__, __LINE__, $result );
		return $result;
  }

}
